LiveJournal = window.arguments[0];
dsPosts = window.arguments[1];
mainWindow = window.arguments[2];
mainDocument = mainWindow.document;
dsPrefs = window.arguments[3];
ljPost = window.arguments[4];
dsAccounts = window.arguments[5];

function Init() {
	// A bit messy, but convenient. Copies all the values from the main window. Why are these options here when
	//	they're already on the post window? Because they're invisble when you load DS in the sidebar, which is
	//	why this is necessary.
	// In: Nothing.
	if (!dsAccounts) {
		document.getElementById("defaults").collapsed = true;
	}
	if (dsPrefs.getIntPref("DetectMethod") == 0) {
		document.getElementById("detectmusic").collapsed = true;
	}
	// Can't use cloneNode. Makes Mozilla 1.7 crash horribly, and Firefox on OS X crash when editable="true". Ugh.
	//document.getElementById("security").appendChild(mainDocument.getElementById("security").firstChild.cloneNode(true));
	mainWindow.boxesGetFocus();
	if (!LiveJournal.usetags) {
		document.getElementById("taghbox").collapsed = true;
	}
	document.getElementById("security").selectedIndex = mainDocument.getElementById("security").selectedIndex;
	//document.getElementById("moods").appendChild(mainDocument.getElementById("moods").firstChild.cloneNode(true));
	var moodlist = document.getElementById("moods");
	moodlist.appendChild(document.createElement("menupopup"));
	for (i = 0; i < LiveJournal.moods.length; i++) {
		moodlist.appendItem(LiveJournal.moods[i].mood, LiveJournal.moods[i].id);
	}
	// Bah.
	if (mainDocument.getElementById("moods").selectedIndex < 0) {
		document.getElementById("moods").label = mainDocument.getElementById("moods").label;
	} else {
		document.getElementById("moods").selectedIndex = mainDocument.getElementById("moods").selectedIndex;
	}
	//document.getElementById("picture").appendChild(mainDocument.getElementById("picture").firstChild.cloneNode(true));
	var pickwlist = document.getElementById("picture");
	pickwlist.appendChild(document.createElement("menupopup"));
	pickwlist.appendItem("[default]", LiveJournal.defaultpicurl);
	
	for (i = 0; i < LiveJournal.pickws.length; i++) {
		pickwlist.appendItem(LiveJournal.pickws[i].pickw, LiveJournal.pickws[i].url);
	}
	document.getElementById("picture").selectedIndex = mainDocument.getElementById("picture").selectedIndex;
	document.getElementById("music").value = mainDocument.getElementById("music").value;
	document.getElementById("taglist").value = mainDocument.getElementById("taglist").value;
	
	document.getElementById("dontautoformat").setAttribute("checked", ljPost.dontautoformat);
	
	document.getElementById("removecomments").setAttribute("checked", ljPost.removecomments);
	document.getElementById("backdate").setAttribute("checked", ljPost.backdate);
}

function OkClicked() {
	// Copies values back to the post window, and also sets defaults if 'set as defaults' is checked.
	// In: Nothing.
	// Out: Nothing.
	mainDocument.getElementById("security").selectedIndex = document.getElementById("security").selectedIndex;
	dsPosts.changeSecurity(mainDocument.getElementById("security").selectedIndex, true);
	mainDocument.getElementById("picture").selectedIndex = document.getElementById("picture").selectedIndex;
	dsPosts.changePicture(mainDocument.getElementById("picture"));
	mainDocument.getElementById("music").value = document.getElementById("music").value;
	mainDocument.getElementById("taglist").value = document.getElementById("taglist").value;

	if (document.getElementById("moods").selectedIndex < 0) {
		mainDocument.getElementById("moods").label = document.getElementById("moods").label;
	} else {
		mainDocument.getElementById("moods").selectedIndex = document.getElementById("moods").selectedIndex;
	}
	
	ljPost.dontautoformat = document.getElementById("dontautoformat").checked;
	mainWindow.dsMidas.dontautoformat = ljPost.dontautoformat;
	ljPost.removecomments = document.getElementById("removecomments").checked;
	ljPost.backdate = document.getElementById("backdate").checked;
	
	if (document.getElementById("defaults").checked) {
		var defsectag = GetTag(dsAccounts.currentaccount, "security");
		defsectag.setAttribute("level", ljPost.security); 
		defsectag.setAttribute("groups", ljPost.allowmask);
		var defaultoptions = GetTag(dsAccounts.currentaccount, "options");
		defaultoptions.setAttribute("backdate", ljPost.backdate);
		defaultoptions.setAttribute("dontautoformat", ljPost.dontautoformat);
		defaultoptions.setAttribute("removecomments", ljPost.removecomments);
		dsAccounts.saveSettings();
	}
	mainWindow.boxesLoseFocus();
}
